# $from and $to are in dBA, n is the number of steps, limit is the maximum allowed output voltage
macro level {from to n limit} {
  # save user config
  set restore_lvl [:set Output,Level]
  set restore_mode [:set Measure,Mode]
  set Measure,Mode dual

  set colors [list red purple darkblue yellow darkgreen brown black] 
  
  set step [expr {pow(10, double($to-$from)/(20*($n-1)))}]

  # set initial output level
  :set Output,Level 0.1
  set ID [:measure]
  :eval $ID -weighting A
  # adjust the output level to reach the desired first SPL step
  set k [expr {pow(10, ($from-[:query $ID RMSweighted])/20.0)}]
  puts stderr "[:query $ID RMSweighted] [:set Output,Level] $k"

  :set Output,Level [expr {$k*[:set Output,Level]}]

  for {set i 0} {$i < $n} {incr i} {
    puts stderr [:set Output,Level]
    if {[:set Output,Level] >= $limit} {
      :message {Maximum allowed output voltage reached}
      break
    }
    :measure
    set ID [:paste]
    :eval $ID -weighting A
    :modify $ID Name [format "%.1f dBA" [:query $ID RMSweighted]] Color [lindex $colors [expr {$i % [llength $colors]}]]
    :set Output,Level [expr {$step*[:set Output,Level]}]
  }
  :set Output,Level $restore_lvl
  :set Measure,Mode $restore_mode
}
